function goodResearch(id="",NeedAA=0)
{
    var cost=getResearch(id,me).power
    var power=playerPower(me)-queuedPower(me)
    
    const HIGH=-10000
    const NORMAL=0
    const LOW=10000
        
    function toward(researchName)
    {
        return findResearch(researchName).map(i=>i.id).includes(id)
    }
    function reached(researchName)
    {
        return getResearch(researchName,me).started || getResearch(researchName,me).done 
    }
    function prefix(researchName)
    {
        return id.startsWith(researchName) 
    }

    if (getResearch(id,me).started)return Infinity

    //core
    if (prefix("R-Sys-Autorepair-General"))return HIGH-2
    if (prefix("R-Struc-Research-Upgrade"))return HIGH-1

    //util
    if (prefix("R-Struc-Factory-Upgrade") || toward("R-Struc-Factory-Upgrade09"))
    {
        if (cost>100 && !reached("R-Vehicle-Metals04"))return LOW+2000
        return (power>3000)?HIGH:(power>1000)?NORMAL+cost:LOW
    }
    if (toward("R-Struc-Power-Upgrade03a"))return (power<1000)?HIGH:LOW
    if (toward("R-Sys-Sensor-Upgrade03"))return NORMAL+cost+100
    if (reached("R-Wpn-Cannon2Mk1") && prefix("R-Struc-RprFac-Upgrade01"))return HIGH+cost

    //armor & body
    if (toward("R-Vehicle-Body11"))return HIGH+cost
    if (toward("R-Cyborg-Metals04"))return HIGH+cost

    if (toward("R-Vehicle-Metals09"))return NORMAL+cost
    if (toward("R-Cyborg-Metals09"))return NORMAL+cost+1
    if (prefix("R-Cyborg-Hvywpn"))return NORMAL+cost


    //weapon (cannon)
    if (prefix("R-Wpn-Cannon") || prefix("R-Wpn-Rail"))
    {
        if (prefix("R-Wpn-Rail")) return HIGH+cost

        if (toward("R-Wpn-RailGun01"))
        {
            if (prefix("R-Wpn-Cannon-Damage")) return HIGH
            if (reached("R-Wpn-Cannon-Damage07"))return HIGH
            return LOW+1
        }
        if (toward("R-Wpn-Cannon3Mk1")) return HIGH+cost
        if (reached("R-Wpn-RailGun01"))return LOW+cost+200
        return NORMAL+cost+400
    }

    //early research
    if (!reached("R-Struc-RepairFacility"))
    {
        if (
            toward("R-Struc-Research-Module") ||
            toward("R-Struc-Factory-Module")  ||
            toward("R-Struc-RepairFacility")  ||
            toward("R-Wpn-MG3Mk1")
        ) return HIGH+cost
    }

    //late research

    if (reached("R-Struc-Research-Upgrade08"))
    {
        if (toward("R-Vehicle-Body09"))return NORMAL+cost+100
        //if (toward("R-Vehicle-Body12"))return NORMAL+cost+200
        if (toward("R-Vehicle-Engine06"))return NORMAL+cost+175
        if (toward("R-Vehicle-Body10"))return NORMAL+cost+300
        if (toward("R-Vehicle-Body14"))return NORMAL+cost+500

        if (prefix("R-Vehicle-Prop"))return LOW+50
        if (toward("R-Defense-HvyHowitzer"))return LOW+100
        if (toward("R-Wpn-LasSat"))return LOW+200
        if (toward("R-Defense-MassDriver"))return LOW+200
        if (toward("R-Defense-HvyArtMissile"))return LOW+250
        if (prefix("R-Sys"))return LOW+300
        if (prefix("R-Struc"))return LOW+300
        
    }

    if (id=="R-Vehicle-Body04")return LOW+300
    return LOW+1000
}

function goodResearch2(id="",NeedAA=0)
{
    return goodResearch(id,NeedAA)-getResearch(id,me).points/100000
}

function monoResearch(lab)
{
    var research=enumResearch()
    if (research.length==0) return
    pursueResearch(lab,min(research,x=>goodResearch2(x.id)).id)
}

function dumbResearch()
{
    var lab=enumStruct(me,RESEARCH_LAB)
    lab.filter(structureIdle).forEach(monoResearch)
}


setTimer(dumbResearch.name, 709+me*3)